// The Main HAM Library
#include "mygba.h"

#define MIXER_FREQ 26757

// Graphics Includes
#include "gfx/ring16x16.pal.c"
#include "gfx/ring16x16.raw.c"
#include "gfx/red.raw.c"
#include "gfx/back.raw.c"
#include "gfx/back.pal.c"

// Global Variables
u8 ring; // Sprite index for the ring
u8 red;
u8 counter; //Sprite for Counter
u8 lifeicon; //Sprite for LifeIcon
u8 sonx = 110;
u8 sony = 50;
u8 frame = 0;
bool newframe = FALSE;
bool runnin = TRUE;

extern const WaveData _binary_leafforest_raw_start;

void vblFunc(); //Declare Frame draw thingie
void nextframe();

int main(void)
{
  sample_info *themusic;

  // Initialize HAMlib
  ham_Init();

  //Intro ------------------------------------------
  ham_InitText(0);
  ham_DrawText(1,1,"Sonic Advance 2 Alpha Hoax");
  ham_DrawText(5,5,"Version 1.2");
  ham_DrawText(10,10,"Press Start");
  ham_DrawText(5,16,"Hoax coded in HAM");

  while (F_CTRLINPUT_START_PRESSED == FALSE);

  //End of Intro -----------------------------------



  // Setup the background mode
  ham_SetBgMode(4);

  TOOL_DMA1_SET(&back_Bitmap,
                                   MEM_BG_PTR,
                                   SIZEOF_32BIT(back_Bitmap),
                                   DMA_TRANSFER_32BIT,
                                   DMA_STARTAT_NOW)

  ham_LoadBGPal(&back_Palette,SIZEOF_16BIT(back_Palette));
  // Initialize the sprite palette
  ham_LoadObjPal(&ring16x16_Palette, 256);
	
  // Setup the sprite
  ring = ham_CreateObj(&ring16x16_Bitmap,0,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,110,50);
  red = ham_CreateObj(&red_Bitmap,1,2,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,28,1);

  // Draw the sprite
  ham_CopyObjToOAM();

  ham_InitMixer(26757);

  // This Tells the GBA to run vblFunc every time a frame is drawn. This keeps the game
  // from drawing frames too fast!
  ham_StartIntHandler(INT_TYPE_VBL,&vblFunc);

  themusic = ham_InitSample((u8*)_binary_leafforest_raw_start.data,1707520,18157);

  while(runnin)
  {
	
	  if(newframe)
	  {
		ham_UpdateMixer();
		if(!themusic->playing)
		{
			//start playing the sample
			ham_PlaySample(themusic);
		}
		newframe = FALSE;
	  }

	  if (F_CTRLINPUT_SELECT_PRESSED && F_CTRLINPUT_B_PRESSED)
	  {
		  runnin = FALSE;
		  while (1)
		  {
			  //Go
		  }
	  }

  }
	
  return; 
}

void vblFunc()
{
	ham_SyncMixer(); //Sync the Audio
	ham_UpdateObjGfx(ring,(void*)&ring16x16_Bitmap[0]);
	ham_CopyObjToOAM(); // Copy block sprite to hardware
	newframe=TRUE;
	nextframe();
	return;
} // End of vblFunc()

void nextframe()
{
	if (runnin)
	{
		if (F_CTRLINPUT_LEFT_PRESSED)
		{
			sonx -= 1;
		}
		 if (F_CTRLINPUT_RIGHT_PRESSED)
		{
			sonx += 1;
		}
		 if (F_CTRLINPUT_UP_PRESSED)
		{
			sony -= 1;
		}
		 if (F_CTRLINPUT_DOWN_PRESSED)
		{
			sony += 1;
		}
		
		frame += 1;
		if (frame == 30)
		{
			ham_SetObjY(red, 200);
		}
		if (frame == 60)
		{
			frame = 0;
			ham_SetObjY(red, 1);
		}
		
		ham_SetObjX(ring,sonx);
		ham_SetObjY(ring,sony);
	}
}
